# "uname -r" output of the kernel to build for, the running one
# if none was specified with "--define 'kernel <uname -r>'"
%{!?kernel: %{expand: %%define kernel %(uname -r)}}

%define kversion %(echo %{kernel} | sed -e s/xen// -)
%define krelver  %(echo %{kversion} | tr -s '-' '_')
%define kmach %(echo %{kernel} | perl -ne 'print "-$1" if /%{_target_cpu}\.(.+)/')

%if %(echo %{kernel} | grep -c xen)
        %{expand:%%define kxensufix -xen}
%endif

Summary: Patched cp2101 driver to handle cp2104 USB-serial bridge
Name: kmod-cp2101-4%{?kxensufix}%{?kmach}
Version: 1.0
Release: 0%{?rcver:.rc%{rcver}}%{?dist}
License: GPL
Group: System Environment/Kernel
URL: http://www.kernel.org/
Source0: kmod-cp2101-4-%{version}%{?rcver:-rc%{rcver}}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root
%if 0%{?fedora}%{?centos_ver}
BuildRequires: kernel%{?kxensufix}-devel-uname-r = %{kversion}
%else
BuildRequires: kernel%{?kxensufix}-devel = %{kversion}
%endif
Requires: /sbin/depmod
%if 0%{?fedora}%{?centos_ver}
Requires(pre): module-init-tools
%else
Prereq: module-init-tools
%endif

%description

This driver is a patched version of the cp2101 driver present in the CentOS 5
standard kernel. This patch enables the driver to handle the cp2104 chipset used
in the USB-serial bridge connected to the OpenVOX jbc1602 LCD display on newer
Elastix appliances.

%prep
%setup -n kmod-cp2101-4-%{version}


%build
%{__make} KVERSION="%{kernel}"


%install
%{__rm} -rf %{buildroot}

# Collect all kernel modules in extra for weak-updates support
%{__mkdir_p} %{buildroot}/lib/modules/%{kernel}/extra
mv cp2101-4.ko %{buildroot}/lib/modules/%{kernel}/extra/
ls %{buildroot}/lib/modules/%{kernel}/extra/*.ko | sed -ne 's:^%{buildroot}::p' > %{buildroot}/lib/modules/%{kernel}/extra/.kmod-cp2101-4-%{version}-%{release}

%{__mkdir_p} %{buildroot}/etc/modprobe.d/
cp cp2101-4-blacklist.conf %{buildroot}/etc/modprobe.d/

%clean
%{__rm} -rf %{buildroot}


%post
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} &>/dev/null || :
if [ -e /sbin/weak-modules ] ; then
	cat /lib/modules/%{kernel}/extra/.kmod-cp2101-4-%{version}-%{release} | /sbin/weak-modules --add-modules
else
	echo "WARN: /sbin/weak-modules not found, cannot associate with kernel updates!"
fi

%preun

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    cp /lib/modules/%{kernel}/extra/.kmod-cp2101-4-%{version}-%{release} /tmp/
fi


%postun
/sbin/depmod -a -F /boot/System.map-%{kernel} %{kernel} &>/dev/null || :

# Run weak-module uninstall on uninstall only
if [ $1 -eq 0 ] ; then
    if [ -e /sbin/weak-modules ] ; then
        cat /tmp/.kmod-cp2101-4-%{version}-%{release} | /sbin/weak-modules --remove-modules
    else
        echo "WARN: /sbin/weak-modules not found!"
    fi
    rm -f /tmp/.kmod-cp2101-4-%{version}-%{release}
fi

%files
%defattr(-, root, root, 0755)
/lib/modules/%{kernel}/extra/*.ko
/lib/modules/%{kernel}/extra/.kmod-cp2101-4-%{version}-%{release}
/etc/modprobe.d/cp2101-4-blacklist.conf

%changelog
* Fri Jul 26 2013 Alex Villacis Lasso <a_villacis@palosanto.com> - 1.0-0
- Initial release for Elastix.

